var AVAILABILITY_TOKEN = Math.floor(Math.random() * 212345);
var SCHEDULED_TOKEN = Math.floor(Math.random() * 212345);
var ACTION = 'Save';
var UPDATE_AVAILABILITY_ID = 0;
var UPDATE_SCHEDULED_ID = 0;

$(document).ready(function () {
    var tableAttachment = $('#tblScheduleAttachment').DataTable({
        responsive: false,
        "scrollX": true,
        "pageLength": 100,
        "order": [],
        "columns": [
            { "data": "file" },
            { "data": "view" },
            { "data": "download" },
            { "data": "delete" },

        ],
        columnDefs: [
            { width: 80, targets: 1 },
            { width: 80, targets: 2 },
            { width: 80, targets: 3 },            
        ],
    });


    $('#attachmnet_schedule_token').val(SCHEDULED_TOKEN);



    $('#btnScheduleAttachment').on('click', function () {

        $('#attachmentScheduledModal').modal('show');
    });
    // $('#btnAvailabilityModal').on('click', function () {

    //     $('#availabilityModal').modal('show');
    // });

    $('input[name="ScheduleSuggestDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        autoUpdateInput: false
    }).on('apply.daterangepicker', function (ev, picker) {
        $(this).val(picker.startDate.format('YYYY-MM-DD'));
    });

    $('input[name="scheduleCargoDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        autoUpdateInput: false
    }).on('apply.daterangepicker', function (ev, picker) {
        $(this).val(picker.startDate.format('YYYY-MM-DD'));
    });

    $('#btnScheduleAction').on('click', function () {
        saveSchedule();
    });

    $('#factory_order_no').on('change', function () {
        getCustomerOrderData(this.value);
    });

    getFactoryOrderNo();
    getCurrencyPrimaryID();
});



Dropzone.options.scheduledDropzone = {
    dictDefaultMessage: 'Drop file here or click to upload!!!!!!!!',
    method: 'POST',
    url: '/sd/customerOrderList/uploadScheduleAttachment',
    params: {
        description: "abc"
    },
    addRemoveLinks: true,
    uploadMultiple: false,
    clickable: true,

    init: function () {
        var myDropzone = this;

        // Here's the change from enyo's tutorial...

        $("#submit-all").click(function (e) {
            e.preventDefault();
            e.stopPropagation();
            myDropzone.processQueue();
        }
        );

        this.on("sending", function (file, xhr, formData) {

            if (!checkStringLength($('#txtScheduleDescription').val(), 500)) {
                showWarningMessage('Data too long for "Description".')
                return;
            }

            // Will sendthe filesize along with the file as POST data.

            formData.append("foo", $('#txtScheduleDescription').val());

        });

        this.on("success", function (file, responseText) {
            var responseText = file.id // or however you would point to your assigned file ID here;
            console.log(responseText); // console should show the ID you pointed to
            // do stuff with file.id ...
            //alert();
        });

        this.on("addedfile", file => {
            console.log(file);
        });

        this.on("complete", function (file) {

            if (ACTION != 'view') {
                this.removeAllFiles(true);
                $('#txtScheduleDescription').val("");
                $('#attachmentScheduledModal').modal('hide');
            }
            allVesselScheduleAttachment(UPDATE_SCHEDULED_ID);
            console.log(file);
        });

        this.on("errormultiple", function (files, response) {

        });
    }
};




function vessel_scheduled(id, status) {

    SCHEDULED_TOKEN = Math.floor(Math.random() * 212345);
    $('#attachmnet_schedule_token').val(SCHEDULED_TOKEN);
    var table = $('#tblScheduleAttachment').DataTable();
    table.clear();
    table.rows.add([]).draw();
    getScheduleHeader(id);
}



function allVesselScheduleAttachment(id) {
    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/allScheduleAttachment/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                var data = [];
                for (var i = 0; i < result.length; i++) {
                    var path = "'" + result[i].file_path + "'";
                    var id = "'" + result[i].vessel_schedule_attachment_id + "'";
                    data.push({
                        "file": result[i].description,
                        "view": '<button type= "button" class="btn btn-primary" onclick="viewScheduleAttachment(' + path + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "download": '<button type= "button" class="btn btn-success" onclick="downloadScheduleAttachment(' + path + ');"><i class="fa fa-download" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteScheduleAttachment(' + id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#tblScheduleAttachment').DataTable();
                //table.clear();
                table.rows.add(data).draw();
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}



function viewScheduleAttachment(file) {
    window.open(file);

}



function downloadScheduleAttachment(file) {
    var link = document.createElement("a");
    link.download = file;
    link.href = file;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    delete link;
}


function deleteScheduleAttachment(id) {
    $.ajax({
        type: "DELETE",
        url: "/pp/customerOrder/deleteScheduleAttachment/" + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage("Attachment has been deleted successfully...");
                allAttachment(UPDATE_ORDER_ID);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });
}



function getScheduleHeader(id) {

    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/getScheduleHeader/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            resetScheduleModal();
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;

                var table = $('#tblScheduleAttachment').DataTable();
                table.clear();
                $('#hidScheduleOrderId').val(id);
                $('#lblScheduleFactoryOrder').text(result.factory_po_num);
                $('#lblScheduleDestination').text(result.address);
                $('#lblScheduleCustomerPo').text(result.purchase_order);
                $('#lblScheduleETA').text(result.delivery_date);
                var currency = result.currency;
                $('#cmbScheduleCurrency').empty();
                for (var i = 0; i < currency.length; i++) {

                    $('#cmbScheduleCurrency').append('<option value="' + currency[i].currency_id + '">' + currency[i].currency + '</option>');
                }
                load_saved_schedule(id);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
    $('#scheduledModal').modal('show');

}


function resetScheduleForm() {
    $('#formSchedule').trigger("reset");
}



function saveSchedule() {

    $.ajax({
        type: "POST",
        url: '/sd/VesselScheduled/saveSchedule',
        data: {
            "token": SCHEDULED_TOKEN,
            "factory_order_no": $('#factory_order_no').val(),
            "eta": $('#txtscheduleEta').val(),
            "customer_po": $('#txtscheduleCustomerPo').val(),
            "designation": $('#txtscheduleDestionation').val(),
            "cargo_ready_date": $('#txtScheduleCargoDate').val(),
            "suggest_vessel": $('#txtScheduleSuggestVessel').val(),
            "suggest_date": $('#txtScheduleSuggestDate').val(),
            "shipping_rate": $('#txtScheduleShippingRate').val(),
            "currency_id": $('#cmbScheduleCurrency').val(),
            "order_id": $('#hidScheduleOrderId').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            resetScheduleForm()
        },
        success: function (response) {
            console.log(response);
            window.location.reload();
            if (response.data.success) {
                toastr.success('Customer data has been saved successful...!');
            } else {
                toastr.error('Something went wrong');
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {

        }

    });
}


function checkStringLength(string, maxLength) {

    if (string.length > maxLength) {
        return false;
    }
    return true;

}

// function saveSchedule() {

//     $.ajax({
//         type: "POST",
//         url: '/sd/customerOrderList/saveSchedule',
//         data: {
//             "token": SCHEDULED_TOKEN,
//             "factory_order_no": $('#lblScheduleFactoryOrder').text(),
//             "eta": $('#lblScheduleETA').text(),
//             "customer_po": $('#lblScheduleCustomerPo').text(),
//             "designation": $('#lblScheduleDestination').text(),
//             "cargo_ready_date": $('#lblScheduleCargoDate').text(),
//             "suggest_vessel": $('#txtScheduleSuggestVessel').val(),
//             "suggest_date": $('#txtScheduleSuggestDate').val(),
//             "shipping_rate": $('#txtScheduleShippingRate').val(),
//             "currency_id": $('#cmbScheduleCurrency').val(),
//             "order_id": $('#hidScheduleOrderId').val(),
//         },
//         headers: {
//             'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
//         },
//         timeout: 800000,
//         beforeSend: function () {

//         },
//         success: function (response) {
//             console.log(response);
//             if (response.data.success) {
//                 toastr.success('Customer data has been saved successful...!');
//                 resetScheduleModal();
//             } else {
//                 toastr.error('Something went wrong');
//             }


//         },
//         error: function (error) {
//             console.log(error);
//             toastr.error('Something went wrong');
//         },
//         complete: function () {

//         }

//     });
// }




function load_saved_schedule(id) {

    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/load_saved_schedule/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            resetScheduleModal();
        },
        success: function (response) {
            console.log(response);

            var result = response.data.result;

            if (result.current_schedule) {
                $('#lblScheduleFactoryOrder').text(result.factory_po_num);
                $('#lblScheduleDestination').text(result.address);
                $('#lblScheduleCustomerPo').text(result.purchase_order);
                $('#lblScheduleETA').text(result.delivery_date);
                $('#txtScheduleSuggestVessel').val(result.suggest_vessel);
                $('#txtScheduleSuggestDate').val(result.suggest_date);
                $('#txtScheduleShippingRate').val(result.shipping_rate);
                var data = [];
                for (var i = 0; i < result.attachment.length; i++) {
                    var path = "'" + result.attachment[i].file_path + "'";
                    var id = "'" + result.attachment[i].vessel_schedule_attachment_id + "'";
                    SCHEDULED_TOKEN = result.attachment[i].token;
                    $('#attachmnet_schedule_token').val(SCHEDULED_TOKEN);
                    data.push({
                        "file": result.attachment[i].description,
                        "view": '<button type= "button" class="btn btn-primary" onclick="viewScheduleAttachment(' + path + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "download": '<button type= "button" class="btn btn-success" onclick="downloadScheduleAttachment(' + path + ');"><i class="fa fa-download" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteScheduleAttachment(' + id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#tblScheduleAttachment').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }


        },
        error: function (error) {
            console.log(error);

        },

    });
}

function getFactoryOrderNo() {
    $.ajax({
        type: "GET",
        url: "/sd/VesselScheduledController/getFactoryOrderNo",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            // console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#factory_order_no").append(
                    '<option value="' +
                    res[i].factory_po_num +
                    '">' +
                    res[i].factory_po_num +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}


function getCurrencyPrimaryID() {
    $.ajax({
        type: "GET",
        url: "/sd/VesselSchedule/getCurrencyPrimaryID",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            // console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#cmbScheduleCurrency").append(
                    '<option value="' +
                    res[i].currency_id +
                    '">' +
                    res[i].currency_code +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}


function getCustomerOrderData(id) {
    $.ajax({
        type: "GET",
        url: "/sd/VesselScheduledController/getCustomerOrderData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                $("#txtscheduleEta").val(result[0].delivery_date);
                $("#txtscheduleCustomerPo").val(result[0].purchase_order);
                $("#txtscheduleDestionation").val(result[0].delivery_address);
                $("#hidScheduleOrderId").val(result[0].order_id);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
        },
    });
}
